/*
  file:         Po_parse_exptext.hh
  created:      Sekhar Muddana circa 1990
  modified:     Pasha Zusmanovich feb 20-21,mar 2 2016
  modification: c++ file ext.
*/

#ifndef __PO_PARSE_EXPTEXT_H
#define __PO_PARSE_EXPTEXT_H

#define	NUM_LETTERS  26  // No. of letters that a polynomial can have


// Each polynomial may have one or more terms seperated by + or -.
// Each term has a term head node as a parent.
// The polynomial has a pointer to the first term head node.
// The term head node points to the next term head node.
// Each term may have a coeficient(scalar), stored in the term_head.
// polynomial is used in the routines parse_exptext() and print_poly().

struct polynomial 
{
  int    degree;
  short  deg_letter[NUM_LETTERS];
  struct term_head* terms;
};	


	
// Each term_head has a term_node as child and another term_head as sibling.  
// So term_head has a child which is the root of a binary tree of term_node's. 

struct term_head 
{
  int coef;   // polynomials are over integers! (which subsequently reduced
              // to a prime field - Q or GF(p)
  struct term_node* term;
  struct term_head* next;
}; 



// A node structure with root term_head.
// If the node is a leaf then left and right pointers are NULL, and letter will
// be the small_letter in the polynomial.
// If not a leaf, letter will be have space and left and right points to another
// term_node.

struct term_node 
{
  char   letter;
  char   number;
  struct term_node* left;
  struct term_node* right;
}; 



struct P_type 
{
  char degrees[NUM_LETTERS];
  char tot_degree;
};


// Takes a polynomial string as input and returns a pointer to polynomial
// structure (internal form for polynomial) 
polynomial* Parse_exptext (char[]); 


#endif // __PO_PARSE_EXPTEXT_H
// end of Po_parse_exptext.hh

