/*
  file:         Po_prod_bst.h
  created:      Sekhar Muddana circa 1990
  modified:     Pasha Zusmanovich feb 21 2009
  modification: fixed func. decl.; ensured included only once
*/

#ifndef __PO_PROD_BST_H
#define __PO_PROD_BST_H

#define    HANDLE_LEN    50

/* 
 * The right hand side of a production is converted to a string.
 * For each production we have a node prod_tnode, having rhs, lhs,
 * and the production number as fields.
 * A sorted binary tree is constructed using these prod_tnode's.
 * Tree is searched for a given rhs returning pointer to the node or
 * NULL if the search fails.
 * Thus reductions are easily done while parsing the polynomial.
 */ 
typedef  struct  prod_tnode {
    char  rhs_str[HANDLE_LEN] ;
    int   lhs ;
    int   prodnum ;
    struct   prod_tnode  *left, *right ;
} PROD_TREENODE, *PROD_TREEPTR;


PROD_TREEPTR Prod_insert (char[], int, int, PROD_TREEPTR*);
PROD_TREEPTR Prod_member (char[], PROD_TREEPTR);
void prt_prod_inorder();

#endif // __PO_PROD_BST_H
// end of Po_prod_bst.h
