/*
  file:         Type_table.h
  created:      Sekhar Muddana May 1990
  modified:     Pasha Zusmanovich feb 12-13,18,27-28,mar 13 2016
  modification: Type converted to vector; C++ file ext.; include once
*/

#ifndef __TYPE_TABLE_H
#define __TYPE_TABLE_H

#include <stdio.h>
#include "Build_defs.hh"

typedef struct tt_node 
{
  Basis begin_basis;
  Basis end_basis;       // indices into Base table
  Type type;
} TT_node; 

Basis BeginBasis (const Name);
bool  CreateTypeTable (const Type&);
void  DestroyTypeTable();
Basis EndBasis (const Name);
Basis FirstBasis (const Name);
Name  FirstTypeDegree (const Degree);
int   GetDegree (const Type&);
int   GetDegreeName (const Name);
void  GetNewType (Type&);
unsigned int GetTargetLen();
bool  IsSubtype (const Name, const Name);
void  NameToType (const Name, Type&);
Name  NextTypeSameDegree (const Name);
void  PrintTypeName (const Name, std::ostream&);
void  SubtractTypeName (const Name, const Name, Name*);
Name  TypeToName (const Type&);
void  UpdateTypeTable (const Name, const Basis, const Basis);

#endif // __TYPE_TABLE_H
// end of Type_table.hh
