/*
  file:         node_mgt.cc
  created:      David P. Jacobs Aug 1992
  modified:     Pasha Zusmanovich feb 13,18,mar 1,10 2016
  modification: support for dmalloc; cleanup; C++ file extensions
*/

// This module contains the routines for albert node memory management. 
// As a node record is needed a call GetRecord() is made. These routines 
// retreive an unused node off of the free list whose head is the 
// node_list_head pointer. When there are no free nodes left then a new block of
// nodes is allocated and carved up into a new list. Deallocated nodes are 
// placed on the front of this list. As new blocks are needed they are allocated
// and linked by the next block field in the block structure.
// When the information has been extracted from the matrix DestroySparseMatrix()
// is called and the list of blocks is stepped thru and deleted.

#ifdef DMALLOC
#include <dmalloc.h>
#endif

#ifdef DEBUGMM
static short int blocknum=0;
#endif

// end of node_mgt.cc
