#!/usr/bin/env bash
#
# file:         test_albert.sh
# created:      pasha mar 27 2012
# modified:     pasha may 16,18-19 2019
# modification: - shebang
#               - diff options
#               - dir name: tests -> input
#               - albert invokation changed
#
# this simple script runs albert feeding it as inputs
# all the files sitting in the subdir 'tests', and comparing
# with respective canonical (trimmed) outputs sitting in the subdir 'out'


cd input
for f in *[^~]; do
	echo running $f 
	../../albert -f ../../.albert 2>/dev/null < $f | ../trim_albert_out.pl > ${f}.out.tmp
	# -Z option is not valid in GNU diff 2.8.1
	# -B option is not valid in non-GNU diff on openbsd
	# now all blank lines are removed by trim_albert_out.pl
	diff -awb ${f}.out.tmp ../out/${f}.out
	rm ${f}.out.tmp
done

# end of test_albert.sh
